Botan 2.19.5 Crypto and TLS for C&

Namespaces | Macros
sha2_64.cpp File Reference
`#include <botan/sha2_64.h>`
`#include <botan/loadstor.h>`
`#include <botan/rotate.h>`
`#include <botan/cpuid.h>`

Go to the source code of this file.

## Namespaces
namespace | Botan

## Macros
#define | SHA2_64_F(A, B, C, D, E, F, G, H, M1, M2, M3, M4, magic)

## Macro Definition Documentation

## ◆ SHA2_64_F

#define SHA2_64_F | ( |  | A,
|  |  | B,
|  |  | C,
|  |  | D,
|  |  | E,
|  |  | F,
|  |  | G,
|  |  | H,
|  |  | M1,
|  |  | M2,
|  |  | M3,
|  |  | M4,
|  |  | magic
| ) |  |

Value:
do { \
const uint64_t E_rho = rotr<14>(E) ^ rotr<18>(E) ^ rotr<41>(E); \
const uint64_t A_rho = rotr<28>(A) ^ rotr<34>(A) ^ rotr<39>(A); \
const uint64_t M2_sigma = rotr<19>(M2) ^ rotr<61>(M2) ^ (M2 >> 6); \
const uint64_t M4_sigma = rotr<1>(M4) ^ rotr<8>(M4) ^ (M4 >> 7); \
H += magic + E_rho + ((E & F) ^ (~E & G)) + M1; \
D += H; \
H += A_rho + ((A & B) | ((A | B) & C)); \
M1 += M2_sigma + M3 + M4_sigma; \
} while(0);

Definition at line 52 of file sha2_64.cpp.